'
'CMM2 M*berto - a distant cousin to Q*bert ;-)
'
'developed by yock1960 - 2021
'
'
#include "playfield.inc"
#include "levels.inc"
 
const TRUE = 1
const FALSE = 0
const DEAD = FALSE
const LIVE = TRUE
const EGG = -1
const EMBRYO = 2
const QBERT = 1       '1-4
const REDEGG = 5      '5-12
const GREENEGG = 13   '13,14
const COILYEGG = 15   '15,16
const COILY = 17      '17-20
const DOH = 21
const WRONGWAY = 23   '23-26
const UGG = 31        '31-34
const SAM = 39        '39-42
const DISC = 47       '47-54
const UP = 0
const DOWN = 2
const UPRIGHT = 0 
const UPLEFT = 1
const DNRIGHT = 0
const DNLEFT = 1
const PLYRTXT = 55
'sound constants
const JUMP = 1
const LIFT= 2
const TUNE = 3
const TUNE2 = 4
const FALL = 5
const EGGDROP = 6
const COILYFALL = 7
const UGGSPEECH = 8
const WRONGWAYSPEECH = 9
const QBERTDIES = 10
const PRIZE = 11
const COILYJUMP = 12
const COINDROP = 13 'does not exist yet
'cube definition
dim c%(2) = (4,4,4)
dim x%(12) = (224,240,256,240, 224,224,240,240, 240,240,256,256,240)
dim y%(12) = (100,92,100,108, 100,120,128,108, 108,128,120,100,108)
dim nxstartcolor%(2)
dim nxfinishcolor%(2) 
dim startcolor%(2)
dim finishcolor%(2) 
dim color1%(2)
dim nextx%(12),nexty%(12)
dim playfield%(8,14)
dim qbert_location!(1)
dim coily_location!(1)
dim col_location!(1)
dim redegg_location!(3,1)
dim elev_location!(1)
dim qhx = 122
dim nz
dim qhy = 20+28
dim side%
dim kb$
dim reggs% = 1      'how many red eggs allowed
dim disc_pairs(14,1)
dim sdisc!(7,2)

'to change color of tops of cubes
dim c1% = (4)
dim x1%(3) = (224,240,256,240)
dim y1%(3) = (100,92,100,108)
dim fc1% = (rgb(183,175,64))
dim flg% = FALSE
'used in make playfield
dim nextx1%(3),nexty1%(3)
dim k% = 6
dim s% = DISC
dim p% = 0
dim q% = 0
dim l%,m%
dim vec!
dim r%
dim t%
dim base_spr%,cur_spr%,b_spr%,c_cur_spr%,re_cur_spr%(3)
dim level% = 1
dim round% = 1
dim field%(14,8)
dim HaveClassic = FALSE
dim HaveNunchuk = FALSE
dim qstate = LIVE
dim cstate = DEAD
dim restate(3)
dim score% = 25
dim cube_cnt% = 0
dim newlevel = TRUE
dim level_colr%
dim round_colr%
'mainloop timer
dim mltimer%
'timer for timing coily drop in
dim ctimer%,ct%
dim fg%,e%
dim c_cnt%,rcnt1%,rcnt2%
dim pawsed = FALSE
dim discnt%
dim cf% = FALSE
dim pflag% = FALSE        'button pressed
dim cflag% = FALSE        'collision occured
dim c_activated% = FALSE
dim qlives% = 3
dim gover% = FALSE
dim testimer=0
dim testimer2
dim cly_int%
dim rdg_int%
dim badguy$
dim dist%
dim exlife_flag=TRUE
dim exlife2_flag=TRUE
 
#MMDEBUG Off

ls_pairs:
data -.5,7.2,.5,6.2,1.5,5.2,2.5,4.2,3.5,3.2,4.5,2.2,5.5,1.2
rs_pairs:
data 14.5,7.2,13.5,6.2,12.5,5.2,11.5,4.2,10.5,3.2,9.5,2.2,8.5,1.2


restore playfield
for l% = 0 to 8
  for m% = 0 to 14
    read field%(m%,l%)
  next
next
math scale field%(),1,playfield%()

restore ls_pairs
for l% = 1 to 7
  read disc_pairs(l%,0)
  read disc_pairs(l%,1)
next
restore rs_pairs
for l% = 8 to 14
  read disc_pairs(l%,0)
  read disc_pairs(l%,1)
next  
calc_discs(1,1)

restate(0) = DEAD
restate(1) = DEAD
restate(2) = DEAD
restate(3) = DEAD

mode 4,12,RGB(BLACK),screen_refresh

'page display 3
cls
page write 3
cls
load png "./assets/qbert_creatures.png",0,0,15
load png "./assets/qbert_cubes_level1.png",129,0,15
load png "./assets/qbert_player_scroll.png",240,0,15
load png "./assets/qbert - misc_text.png",347,0,15
load png "./assets/qbert_spinning_discs.png",0,160,5
load png "./assets/qbert_alphanumeric.png",0,225,15
load png "./assets/qbert_doh.png",0,256,15
play modfile "./assets/qbert_sounds.mod",22050

'qbert 1-4
sprite read QBERT+UP,0,0,16,16,3
sprite read QBERT+UP+1,16,0,16,16,3
sprite read QBERT+DOWN,64,0,16,16,3
sprite read QBERT+DOWN+1,80,0,16,16,3

'make 'lives' character
blit 0,0,mm.hres-16,mm.vres-16,16,16,3
image resize mm.hres-16,mm.vres-16,16,16,mm.hres-32,mm.vres-16,12,12,3



'red egg 5-12
sprite read REDEGG,  16,16,16,16,3    'egg #1
sprite read REDEGG+1, 0,16,16,16,3
sprite read REDEGG+2,16,16,16,16,3    'egg #2
sprite read REDEGG+3, 0,16,16,16,3
sprite read REDEGG+4,16,16,16,16,3    'egg #3
sprite read REDEGG+5, 0,16,16,16,3
sprite read REDEGG+6,16,16,16,16,3    'egg #4
sprite read REDEGG+7, 0,16,16,16,3


'green ball 13-14
sprite read GREENEGG,  48,16,16,16,3
sprite read GREENEGG+1,32,16,16,16,3


'coily egg 15-16
sprite read COILYEGG,  80,16,16,16,3
sprite read COILYEGG+1,64,16,16,16,3

'coily 17-20
sprite read COILY+UP,0,32,16,32,3
sprite read COILY+UP+1,16,32,16,32,3
sprite read COILY+DOWN,64,32,16,32,3
sprite read COILY+DOWN+1,80,32,16,32,3

'Qbert swears 21
sprite read DOH,0,256,50,27,3

'wrongway 23-30
sprite read WRONGWAY+UPRIGHT,   0,32,16,32,3
sprite read WRONGWAY+UPRIGHT+1,16,32,16,32,3
sprite read WRONGWAY+UPLEFT,   32,32,16,32,3
sprite read WRONGWAY+UPLEFT+1, 48,32,16,32,3
sprite read WRONGWAY+DNRIGHT,  64,32,16,32,3
sprite read WRONGWAY+DNRIGHT+1,80,32,16,32,3
sprite read WRONGWAY+DNLEFT,   96,32,16,32,3
sprite read WRONGWAY+DNLEFT+1,112,32,16,32,3

'ugg 31-38
sprite read UGG+UPRIGHT,   0,32,16,32,3
sprite read UGG+UPRIGHT+1,16,32,16,32,3
sprite read UGG+UPLEFT,   32,32,16,32,3
sprite read UGG+UPLEFT+1, 48,32,16,32,3
sprite read UGG+DNRIGHT,  64,32,16,32,3
sprite read UGG+DNRIGHT+1,80,32,16,32,3
sprite read UGG+DNLEFT,   96,32,16,32,3
sprite read UGG+DNLEFT+1,112,32,16,32,3

'sam 39-46
sprite read SAM+UPRIGHT,   0,32,16,32,3
sprite read SAM+UPRIGHT+1,16,32,16,32,3
sprite read SAM+UPLEFT,   32,32,16,32,3
sprite read SAM+UPLEFT+1, 48,32,16,32,3
sprite read SAM+DNRIGHT,  64,32,16,32,3
sprite read SAM+DNRIGHT+1,80,32,16,32,3
sprite read SAM+DNLEFT,   96,32,16,32,3
sprite read SAM+DNLEFT+1,112,32,16,32,3


'disc
sprite read DISC,129,193,16,16,3
sprite read DISC+1,145,193,16,16,3
sprite read DISC+2,161,193,16,16,3
sprite read DISC+3,177,193,16,16,3
'disc with qbert on board
sprite read DISC+4,0,181,16,21,3
sprite read DISC+5,16,181,16,21,3
sprite read DISC+6,32,181,16,21,3
sprite read DISC+7,48,181,16,21,3


'player number
blit read  62,347,0,8,12,3
'level text
blit read  61,347,12,30,8,3
'round text
blit read  60,347,20,30,8,3
'chage to text
blit read  59,347,28,50,8,3
'right arrow
blit read  58,347+24,0,8,8,3
'left arrow
blit read  57,347+32,0,8,8,3


'page display 0

page write 0



' used for cube flashing
blit read 64,120,89,9*28,9*28
blit read 63,120,89,9*28,9*28,5






l% = l% - 1
flg% = TRUE

qbert_location(0) = 7
qbert_location(1) = 1

selectinputdevice(1) 

new_game

do while kb$ <> "q" 

kb$ = inkey$ 
'mltimer% = timer

if kb$ = "p" and not pawsed then
  pawsed = TRUE
  settick 0,coilly,1
  settick 0,redeg,4
  cly_int%=1000
  rdg_int%=1150
else if kb$ = "p" and pawsed then
  pawsed = FALSE
  settick cly_int%,coilly,1
  settick rdg_int%,redeg,4
end if


if qstate = DEAD then
  qstate = LIVE
  qbert_location(0) = 7
  qbert_location(1) = 1
  cly_int% = 2000

  if CSTATE <> DEAD then
    sprite hide c_cur_spr%    
    cstate = DEAD
    ct% = 0
    settick cly_int%,coilly,1
  end if

  drop_in(TRUE)

end if

loop

sub manage_lives(lives%)
  
  select case lives%


    case 4
      blit mm.hres-32,mm.vres-16,20,130,12,12,3
      blit mm.hres-32,mm.vres-16,20,150,12,12,3
      blit mm.hres-32,mm.vres-16,20,170,12,12,3
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 3
      blit 20,210,20,130,12,12,1
      blit mm.hres-32,mm.vres-16,20,150,12,12,3
      blit mm.hres-32,mm.vres-16,20,170,12,12,3
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 2
      blit 20,210,20,150,12,12,1
      blit mm.hres-32,mm.vres-16,20,170,12,12,3
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 1
      blit 20,210,20,170,12,12,1
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 0
      blit 20,210,20,190,12,12,1

    case -1
      game_over
      new_game

    end select

      
end sub   'manage lives


sub game_over
  local k$

   gover% = TRUE
   do while k$ = ""
    k$ = inkey$ 
    screen_refresh
   loop
   gover% = FALSE

end sub   ' game over
  

sub collision
  local  c


  cf% = TRUE
     
    
     if coily_location!(0) = qbert_location!(0) then
       if coily_location!(1) = qbert_location!(1) then      
          settick 100,coilly,1
          settick 0,redeg,4
          rdg_int% = 0
          cly_int% = 0
          col_location!(0) = qbert_location!(0)
          col_location!(1) = qbert_location!(1)
          cflag%=COILY
          badguy$ = "Coily"
          dist% = sprite(d,cur_spr%,c_cur_spr%)
'          diagnostic
       end if
     else 
      for c = 0 to reggs%-1
        if redegg_location!(c,0) = qbert_location!(0) then
          if redegg_location!(c,1) = qbert_location!(1) then      
            settick 0,coilly,1
            settick 100,redeg,4
            rdg_int% = 0
            cly_int% = 0
            col_location!(0) = qbert_location!(0)
            col_location!(1) = qbert_location!(1)
            cflag% = REDEGG
            badguy$ = "Red Egg"
            dist% = sprite(d,cur_spr%,re_cur_spr%(c))
 '          diagnostic
          end if
        end if
      next
     end if

    cf% = FALSE    
end sub   ' collision


sub diagnostic
  local k$


  settick 0,coilly,1
  settick 0,redeg,4
  cly_int%=1000
  rdg_int%=1150
mmdebug  text 200,10,badguy$+","+str$(col_location!(0))+","+str$(col_location!(1))+","+str$(dist%)+"     ",L,,,RGB(WHITE)
mmdebug  text 200,30,"num sprites= "+str$(sprite(N)),L,,,RGB(WHITE)
  
  do while k$ = ""
    k$ = inkey$

  loop



  settick cly_int%,coilly,1
  settick rdg_int%,redeg,4
    

end sub


sub redeg
  local hd%,vd%,n%,l%

' exit sub

  if cflag% = REDEGG then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    exit sub
  end if

  for n% = 0 to reggs%-1
   if restate(n%) = EMBRYO then
      rdg_int% = 200
      settick rdg_int%,redeg,4
      restate(n%) = EGG
      exit sub
   end if
  next

  for n% = 0 to reggs%-1
    if restate(n%) = EGG then
      rdg_int% = 1000
      settick rdg_int%,redeg,4
    end if
  next
    
  if reggs% = 2 and rcnt2% = 0 then
    rcnt2% = 1
  end if

 
  inc rcnt1%,1
  
  
  if rcnt1% >= 4 then
    if restate(0) = DEAD then  'if red egg is not on playfield
        redeg_dropin(0)

'        exit sub
        rcnt1% = 0
        if reggs% = 2 then
          rcnt2% = 1
        end if
      end if
  end if

  if rcnt2% > 0 then
    inc rcnt2%,1
    if rcnt2% >=7 then 
      if restate(1) = DEAD then
        redeg_dropin(1)
'        exit sub
        rcnt2% = 0
      end if
    end if
  end if
  
  vd% = 1


  for n% = 0 to reggs%-1
    if restate(n%) = EGG then
      select case redegg_location!(n%,1)

        case 1,2,3,4,5,6,7
          hd% = int(rnd*2)+1
          if hd% = 2 then 
            hd% = -1
          end if
          red_egg_drop(n%,hd%,vd%)

        case 8
          for l% = 0 to 15
            sprite show REDEGG+(n%*2)+1,sprite(x,REDEGG+(n%*2)+1),sprite(y,REDEGG+(n%*2)+1)+l%,1
            pause 5
          next
          restate(n%) = DEAD
          if sprite(x,REDEGG+(n%*2)+1) <> 10000 then
            sprite hide safe REDEGG+(n%*2)+1
          end if
          re_cur_spr%(n%) = REDEGG+(n%*2)
          settick 1000,redeg,4

      end select
    end if    
next

end sub   'redeg



sub coilly
  local hd%,vd% 

'  exit sub
   
   if cstate = EMBRYO then
      cly_int% = 200
      settick cly_int%,coilly,1
      cstate = EGG
      exit sub
   end if


  if cflag% = COILY then
    collision_recover    
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    exit sub
  end if

  if cstate = DEAD then
      cly_int% = 1000
      settick cly_int%,coilly,1
    coily_dropin
    cstate = EMBRYO
  end if
'  end if

  vd% = 1

  if cstate = EGG then
      cly_int% = 1000
      settick cly_int%,coilly,1

    if not c_activated%  then
      sprite interrupt collision    
      c_activated% = TRUE
    end if

    select case coily_location!(1)
      case 1,2,3,4,5,6
        hd% = int(rnd*2)+1
        if hd% = 2 then 
          hd% = -1
        end if
        egg_drop(COILYEGG,hd%,vd%)

      case 7
        cstate = LIVE
        sprite hide COILYEGG+1
        c_cur_spr% = COILY+UP
        sprite show c_cur_spr%,((coily_location!(0))*16)+qhx,qhy+8+(28*(coily_location!(1)-1)+14),1
        settick 1000,coilly,1
        exit sub
    end select
  end if    


  if cstate = LIVE then
    kill_vector
    coily_hop(kvh%,kvv%)
  end if    
  ct2% = timer


end sub   'coily

sub kill_vector

  kvh% = qbert_location!(0) - coily_location!(0)
  if kvh% < 0 then 
    kvh% = -1
  else
    kvh% = 1
  end if

  kvv% = qbert_location!(1) - coily_location!(1)
  if kvv% > 0 then
    kvv% = 1
  else
    kvv% = -1
  end if

end sub



' flash all the cube tops at level completed
sub cube_flash
 local l%

  sprite hide safe cur_spr%
  play modsample TUNE2,1,64,22050   'tune-2.wav  all tune sounds on channel 1


  for l% = 1 to 10
    if l% = 1 or l% = 3 or l% = 5 or l% = 7 or l% = 9 then
      blit write 64,120,89
    else
      blit write 63,120,89
    end if
    pause 125
  next

  pause 1000


  if round% < 4 then
    inc round%
    settick 2000,coilly,1
    settick 4000,redeg,4
    ctimer% = timer
    ct% = timer
    cstate = DEAD
    for l% = 0 to reggs%
      restate(l%) = DEAD
    next
  else
    round% = 1
    inc level%
    if reggs% < 3 then
      inc reggs%
    end if
    newlevel = TRUE
    settick 2000,coilly,1
    settick 4000,redeg,4
    ctimer% = timer
    ct% = timer
    cstate = DEAD
    for l% = 0 to reggs%
      restate(l%) = DEAD
    next
  end if

  drop_in(TRUE)
    
end sub

sub new_game
  level% = 1
  round% = 1
  qlives% = 3
  score% = 25
  cube_cnt% = 0
  newlevel = TRUE
  rcnt1% = 0
  rcnt2% = 0
  cls

  timer = 0

  flg% = TRUE


  ' player numer
  blit write 62,68,8
  'level
  blit write 61,340,80
  level_colr% = pixel(343,85)


  'round
  blit write 60,340,90
  round_colr% = pixel(340,95)


  'change to
  blit write 59,10,50


'  reset playfield
  math scale playfield%(),1,field%()
  calc_discs(level%,round%)

draw_cubes(FALSE)

manage_lives(qlives%)


play modsample TUNE,1,64,22050   'tune.wav  all tunes on channel 1

drop_in(TRUE)

b_spr% = QBERT+DOWN
cur_spr% = QBERT+DOWN

ctimer% = timer

mltimer% = timer

end sub

sub screen_refresh
  static t3%
  local t1%,t2%


  if flg% = FALSE then exit sub

  t2% = timer
  if t2% >= 120 then
    discs
    t3% = t3% + t2%
    timer = 0
  end if
  if t3% >= 360 then
    arrows
    t3% = 0
  end if


  text 380,80,str$(level%)+" ",L,7,,level_colr%
  text 380,90,str$(round%)+" ",L,7,,round_colr%


  if score% > 0 then
    text 20,27,str$(score%),L,,,RGB(RED)
  end if
end sub

sub discs
  local i%

  s% = s% + 1
  p% = p% + 1


  if s% > DISC+3 then s% = DISC
  if p% > 6 then p% = 1


  sprite read PLYRTXT,240,0+p%*8,53,8,3

  for i% = 1 to 7
    if sdisc!(i%,0) = TRUE then
      blit write s%,sdisc!(i%,1)*16+qhx,sdisc!(i%,2)*28+qhy
    end if
  next

' player
   blit write PLYRTXT,10,10
end sub


sub arrows
  q% = q% + 1
  if q% = 3 then q% = 0

  if q% = 0 then

    box 70,50,17,10,,RGB(black),RGB(black)
    box 110,50,20,10,,RGB(black),RGB(black)

    if pawsed then
      text 150,30,"Game Paused",L,3,,RGB(RED)

    else if gover% then
      text 150,30,"Game Over - press a key",L,2,,RGB(RED)
    else
      text 150,30,"                       ",L,3,,RGB(RED)
    end if

  
  else if q% = 1 then
    blit write 57,120,50
    blit write 58,70,50
  else if q% = 2 then
    blit write 57,110,50
    blit write 58,80,50
    if pawsed then
      text 150,30,"           ",L,3,,RGB(RED)
    end if
    if gover% then
      text 150,30,"                       ",L,2,,RGB(RED)
    end if
  end if
mmdebug      text 150,mm.vres-40,"coily interval= "+str$(cly_int%)+"   ",L,,,RGB(WHITE)
mmdebug      text 150,mm.vres-20,"red egg interval= "+str$(rdg_int%)+"   ",L,,,RGB(WHITE)
mmdebug      text mm.hres-75,20,"rcnt1%= "+str$(rcnt1%),L,,,RGB(WHITE)
mmdebug      text mm.hres-75,40,"rcnt2%= "+str$(rcnt2%),L,,,RGB(WHITE)
  
end sub  



sub elevator(lift,dr)
  local m%,r%,fg%,rloop%


  sdisc!(lift,0) = FALSE

  elev_location!(0) = sdisc!(lift,1)
  elev_location!(1) = sdisc!(lift,2)

'blank out used disc
  box sdisc!(lift,1)*16+qhx,sdisc!(lift,2)*28+qhy,16,16,,RGB(BLACK),RGB(BLACK) 


' choose sprite based on direction
  if dr = 1 then
    sprite read DISC+4,0,181,16,21,3
    sprite read DISC+5,16,181,16,21,3
    sprite read DISC+6,32,181,16,21,3
    sprite read DISC+7,48,181,16,21,3
  else
    sprite read DISC+4,0,160,16,21,3
    sprite read DISC+5,16,160,16,21,3
    sprite read DISC+6,32,160,16,21,3
    sprite read DISC+7,48,160,16,21,3
  end if


  ehv% = dr


  fg% = FALSE


  e% = DISC+4

  settick 300,lift_hop,2

end sub


sub lift_hop

' fg% = FALSE

    for r% = 1 to 16

      if e% = DISC+8 then 
         e% = DISC+4
      end if
      if e% > DISC+4 and e% <= DISC+7 then
        sprite hide safe e% - 1
        pause 7
      end if

      if ehv% = -1 then
        sprite show e%,((elev_location!(0)*16)+qhx)-r%,(elev_location!(1)*28+qhy-5)-r%*1.8,1
        pause 10
      else
        sprite show e%,((elev_location!(0)*16)+qhx)+r%,(elev_location!(1)*28+qhy-5)-r%*1.8,1
        pause 10
      end if
      inc e%

    next

    fg% = TRUE


  if ehv% = -1 then
    inc elev_location!(0),-1
  else
    inc elev_location!(0),1
  end if

  inc elev_location!(1),-1

  if ehv% = 1 then  
    if elev_location!(0) >= 6.5 then
      sprite hide safe e%-1
      settick 0,lift_hop,2
      cly_int% = 1000
      settick cly_int%,coilly,1
      drop_in(FALSE)
    end if
  end if

  if ehv% = -1 then  
    if elev_location!(0) <= 7.5 then
      sprite hide safe e%-1
      settick 0,lift_hop,2
      cly_int% = 1000
      settick cly_int%,coilly,1
      drop_in(FALSE)
    end if
  end if
    
'  end if

end sub   'lift hop


sub drop_in(reset%)
  local w%

  if reset% then
    cly_int% = 4000
    rdg_int% = 1000
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  else
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4  
  end if

  if newlevel = TRUE then 
    c_cnt% = 0
    if c_cnt% = 0 then
      c_cnt% = 1
      newlevel = FALSE  
    coily_location!(0) = 0
    coily_location!(1) = 0
    for w% = 0 to reggs%-1
      redegg_location!(w%,0) = 0
      redegg_location!(w%,1) = 0
    next

    end if
  end if

 qbert_location!(0) = 7
 qbert_location!(1) = 1


  pause 100

  cur_spr% = QBERT+DOWN+1

  for w% = 1 to 20
    sprite show safe QBERT+DOWN+1,7*16+qhx,qhy+(28-13)+w%,1,0
    pause 10
  next

   sprite hide cur_spr%

  if level% = 1 then 
    if field%(7,1) = 0 then
      inc field%(7,1)
      inc cube_cnt%
    end if
    math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
    math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
    polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
  end if


  if level% = 2 then
    if field%(7,1) = 0 then
      inc field%(7,1)
      math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
      math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
      polygon c1%,nextx1%(),nexty1%(),color1%(0),color1%(0)
    else if field%(7,1) = 1 then
      inc field%(7,1)
      inc cube_cnt%
      math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
      math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
      polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
    end if
  end if

 inc cur_spr%,-1
 sprite show cur_spr%,7*16+qhx,28+qhy+10,1


mmdebug      text 100,10,"cube count = "+str$(cube_cnt%)+" ",L,,,RGB(WHITE)
    

  if qlives% = 3 then
    inc qlives%,-1
    manage_lives(qlives%)
  else
    manage_lives(qlives%)
  end if

end sub   'drop in


sub redeg_dropin(eggno%)
  local m%
  static side%=1

  


  if restate(eggno%) = DEAD then
      restate(eggno%) = EMBRYO
    side% = side%*-1
  end if


  for m% = 1 to 28    '40
    sprite show safe REDEGG+eggno%,((7+side%)*16)+qhx,qhy+((28*-1))+m%,1,0
    re_cur_spr%(eggno%) = REDEGG+eggno%
    pause 5
  next
  sprite hide REDEGG+eggno%


  sprite show REDEGG+1+eggno%,((7+side%)*16)+qhx,qhy+8+((28*2)-0),1,0



  pause 20
  re_cur_spr%(eggno%) = REDEGG+eggno%+1

  settick rdg_int%,redeg,4
 
  redegg_location!(eggno%,0) = 7+side%
  redegg_location!(eggno%,1) = 2

'diagnostic to understand where program returns after a sprite collision
 cf% = FALSE
 

  testimer = timer

end sub   'redeg_dropin


sub coily_dropin
  local m%

  if cf% then exit sub

  if cstate = DEAD then
      cstate = EMBRYO

      side% = rnd*2 '+1
      if side% > 1 then 
        side% = -1
      else
        side% = 1
      end if
  end if

  c_cur_spr% = COILYEGG

  for m% = 1 to 28  '40
    sprite show safe c_cur_spr%,((7+side%)*16)+qhx,qhy+((28*-1))+m%,1,0
    pause 5
  next
  sprite hide c_cur_spr%


  c_cur_spr% = COILYEGG+1
  cly_int% = 1000
  sprite show c_cur_spr%,((7+side%)*16)+qhx,qhy+8+((28*1)-0)+m%,1,0
'  pause 50
  settick cly_int%,coilly,1
 
  coily_location!(0) = 7+side%
  coily_location!(1) = 2


end sub   'red egg dropin


sub red_egg_drop(eggno%,horz%,vert%)   'eggno% 0=1st egg, 1=2nd egg, 2=3rd egg, 3=4th egg
' local b_spr%
 local tmp_loc!(1),n
 static f% = 1

  play modsample EGGDROP,1,64,22050   'jump-3.wav  all egg sounds on channel 1, shared with tunes

 if sprite(x,REDEGG+(2*eggno%)+1) <> 10000 then
    sprite hide safe REDEGG+(2*eggno%)+1
 end if


    re_cur_spr%(eggno%) = (2*eggno%)+REDEGG
    if horz% = 1 then
      tmp_loc!(0) = redegg_location!(eggno%,0) + 1
    else
      tmp_loc!(0) = redegg_location!(eggno%,0) - 1
    end if

    tmp_loc!(1) = redegg_location!(eggno%,1) + 1


  if horz% = 1 then
    sprite show safe REDEGG+(2*eggno%),((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    re_cur_spr%(eggno%) = REDEGG+(2*eggno%)
  else
    sprite show safe REDEGG+(2*eggno%),((tmp_loc!(0)+1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    re_cur_spr%(eggno%) = REDEGG+(2*eggno%)
  end if
  pause 30
  sprite show safe REDEGG+(2*eggno%),((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-0)-5),1 
  pause 30
  
  sprite hide safe REDEGG+(2*eggno%)

  sprite show safe REDEGG+(2*eggno%)+1,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1))),1 
  re_cur_spr%(eggno%) = REDEGG+(2*eggno%)+1

  pause 30


    redegg_location!(eggno%,0) = tmp_loc!(0)
    redegg_location!(eggno%,1) = tmp_loc!(1)
 
 cf% = FALSE


end sub   'redegg drop


sub egg_drop(spr%,horz%,vert%)
' local b_spr%
 local tmp_loc!(1),n
 static f% = 1

play modsample EGGDROP,1,64,22050   'jump-3.wav  all egg sounds on channel 1

 sprite hide safe spr%+1


  if spr% = COILYEGG then
    c_cur_spr% = spr%
    if horz% = 1 then
      tmp_loc!(0) = coily_location!(0) + 1
    else
      tmp_loc!(0) = coily_location!(0) - 1
    end if
    tmp_loc!(1) = coily_location!(1) + 1
  end if


  if horz% = 1 then
    sprite show safe spr%,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    c_cur_spr% = spr%
  else
    sprite show safe spr%,((tmp_loc!(0)+1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    c_cur_spr% = spr%
  end if
  pause 30
  sprite show safe spr%,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-0)-5),1 
  pause 30

  sprite hide safe spr%

  sprite show safe spr%+1,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1))),1 
  c_cur_spr% = spr%+1

  pause 30

  

    coily_location!(0) = tmp_loc!(0)
    coily_location!(1) = tmp_loc!(1)


 cf% = FALSE

  if cflag% = COILY then
    collision_recover
    settick cly_int%,coilly,1
  else if cflag% = REDEGG then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  end if


end sub   'egg drop



sub coily_hop(horz%,vert%)
 local b_spr%,qr%
 local tmp_loc!(1),l%
 static f% = 1

 play modsample 12,3,64,22050   'jump-4.wav  all coily sounds on channel 3

 sprite hide safe c_cur_spr% 'what coily sprite is currently showing

    if horz% = 1 then
      tmp_loc!(0) = coily_location!(0) + 1
    else
      tmp_loc!(0) = coily_location!(0) - 1
    end if

    if coily_location!(1) = 7 then vert% = -1
      
    if vert% = 1 then
      tmp_loc!(1) = coily_location!(1) + 1
    else
      tmp_loc!(1) = coily_location!(1) - 1
    end if


    select case field%(tmp_loc!(0),tmp_loc!(1))
      case -1
        play modsample 7,3,64,22050   'snake-fall.wav  all coily sounds on channel 3


       sprite show safe c_cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0))-14),1,qr%
       pause 50

       l% = 0
       do while sprite(y,c_cur_spr%) < 400
         sprite show c_cur_spr%,sprite(x,c_cur_spr%),sprite(y,c_cur_spr%)+l%,1
         inc l%
         pause 5
       loop


       sprite hide safe c_cur_spr%

     
        cstate = dead
        exit sub
        
      
    end select


 if horz% = 1 then
  if vert% = 1 then
    qr% = 0
    b_spr% = COILY+DOWN
  else
    qr% = 0
    b_spr% = COILY+UP
  end if
 else
  if vert% = 1 then
    qr% = 1
    b_spr% = COILY+DOWN
  else
    qr% = 1
    b_spr% = COILY+UP
  end if
 end if


 c_cur_spr% = b_spr%+1

 sprite show safe c_cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0))-14),1,qr%
 pause 50

 sprite hide safe c_cur_spr%

 c_cur_spr% = b_spr%
 sprite show safe c_cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0)-14),1,qr%



    coily_location!(0) = tmp_loc!(0)
    coily_location!(1) = tmp_loc!(1)
    
 cf% = FALSE

  if cflag% = COILY then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  else if cflag% = REDEGG then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  end if

  cflag% = FALSE

end sub 'coily hop

sub collision_recover
  local n

    if cflag% = COILY then
          play modsample QBERTDIES,2,64,22050   'swear.wav  all qbert sounds on channel 2
          qstate = DEAD
          cstate = DEAD

          
          coily_location!(0)=-99
          coily_location!(1)=-99

          sprite show DOH,qhx+((qbert_location!(0)-1)*16),qhy+(qbert_location!(1)*28)-20,1
          
          PAUSE 1000          
          sprite hide DOH

          for n=0 to reggs%-1
            restate(n) = DEAD
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
            if sprite(x,re_cur_spr%(n)) <> 10000 then
              sprite hide safe re_cur_spr%(n)
             end if
          next


          if sprite(x,c_cur_spr%) <> 10000 then
            sprite hide safe c_cur_spr%
          end if
          sprite hide safe cur_spr%
          if sprite(x,cur_spr%+1) <> 10000 then
            sprite hide safe cur_spr%+1
          end if

          if field%(qbert_location!(0),qbert_location!(1)) = 1 then
            math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
            math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
            polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
          end if

          rcnt1%=0
          rcnt2%=0
          cly_int% = 2000
          rdg_int% = 1000

        else if cflag% = REDEGG then

          for n = 0 to reggs%-1
mmdebug             text 200,10,"red egg "+","+str$(n)+","+str$(redegg_location!(n,0))+","+str$(redegg_location!(n,1))+"     ",L,,,RGB(WHITE)
          next

          play modsample QBERTDIES,2,64,22050   'swear.wav  all qbert sounds on channel 2
          qstate = DEAD
          cstate = DEAD


          sprite show DOH,qhx+(qbert_location!(0)-1)*16),qhy+(qbert_location!(1)*28)-20,1
          PAUSE 1000          
          sprite hide DOH

          coily_location!(0)=-99
          coily_location!(1)=-99

          for n = 0 to reggs%-1
            restate(n) = DEAD  
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
            if sprite(x,re_cur_spr%(n)) <> 10000 then
              sprite hide safe re_cur_spr%(n)
            end if
          next


          sprite hide safe cur_spr%
          if sprite(x,cur_spr%+1) <> 10000 then
            sprite hide safe cur_spr%+1
          end if

          if sprite(x,c_cur_spr%) <> 10000 then
            sprite hide safe c_cur_spr%
          else if sprite(x,c_cur_spr%+1) <> 10000 then
            sprite hide safe c_cur_spr%+1  
          end if

          if field%(qbert_location!(0),qbert_location!(1)) = 1 then
            math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
            math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
            polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
          end if

          rcnt1%=0
          rcnt2%=0
          cly_int% = 2000
          rdg_int% = 1000

      else if cflag% = QBERT then
          for n = 0 to reggs%
            if sprite(x,re_cur_spr%(n)) <> 10000 then
              sprite hide safe re_cur_spr%(n)
             end if
          next
          if sprite(x,c_cur_spr%) <> 10000 then
            sprite hide safe c_cur_spr%
          else if sprite(x,c_cur_spr%+1) <> 10000 then
            sprite hide safe c_cur_spr%+1  
          end if

          if sprite(x,cur_spr%) <> 10000 then
            sprite hide safe cur_spr%
          else if sprite(x,cur_spr%+1) <> 10000 then
            sprite hide safe cur_spr%+1
          end if
  
          qstate = DEAD
          cstate = DEAD
          for n = 0 to reggs%-1
            restate(n) = DEAD  
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
          next
          coily_location!(0)=-99
          coily_location!(1)=-99
          rcnt1%=0
          rcnt2%=0
          cly_int% = 2000
          rdg_int% = 1000

    end if

            inc qlives%,-1
            manage_lives(qlives%)
'            if qlives% < 0 then
'              game_over
'            end if

    cflag% = FALSE

end sub   'collision_recover


sub hop(horz%,vert%)
 local tmp_spr%,bonus%,qr%,w%,l%
 local tmp_loc!(1)
 static f% = 1

  if cf% then exit sub

play modsample 1,2,64,22050   'jump.wav  all qbert sounds on channel 2

  tmp_spr% = cur_spr%


    if horz% = 1 then
      tmp_loc!(0) = qbert_location!(0) + 1
    else
      tmp_loc!(0) = qbert_location!(0) - 1
    end if
    if vert% = 1 then
      tmp_loc!(1) = qbert_location!(1) + 1
    else
      tmp_loc!(1) = qbert_location!(1) - 1
    end if

    if sprite(x,tmp_spr%) <> 10000 then
      sprite hide tmp_spr%
    end if


    select case field%(tmp_loc!(0),tmp_loc!(1))


    case 0,1,2
       if horz% = 1 then
         if vert% = 1 then    '(1,1)
          qr% = 0 'not mirrored
          b_spr% = QBERT+DOWN     '1+2 = 3
        else     ' (1,-1)
          qr% = 0 ' not mirrored
          b_spr% = QBERT+UP       '1+0 = 1
        end if
       else
        if vert% = 1 then     '(-1,1)
          qr% = 1 'mirrored
          b_spr% = QBERT+DOWN     '1+2 = 3
        else                  '(-1,-1)
          qr% = 1 'mirrored
          b_spr% = QBERT + UP   '1+0 = 1
        end if
      end if

      sprite show b_spr%+1,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5+14),1,qr% 'QBERT+DNRIGHT+1
      cur_spr% = b_spr%+1

      if level% = 1 then
        if field%(tmp_loc!(0),tmp_loc!(1)) = 0 then
          math add x1%(),(tmp_loc!(0)-7)*16,nextx1%()
          math add y1%(),(tmp_loc!(1)-1)*28,nexty1%()
          polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
    
          inc field%(tmp_loc!(0),tmp_loc!(1))
          score% = score% + 25
          if score% >= 6000 then        
            if qlives% <= 3 then
              if exlife_flag=TRUE then            
                inc qlives%            
                manage_lives(qlives%)
                exlife_flag=FALSE
              end if
            end if
          end if
          inc cube_cnt%
        end if

      else if level% = 2 then      
        if field%(tmp_loc!(0),tmp_loc!(1)) = 0 then
          math add x1%(),(tmp_loc!(0)-7)*16,nextx1%()
          math add y1%(),(tmp_loc!(1)-1)*28,nexty1%()
          polygon c1%,nextx1%(),nexty1%(),color1%(0),color1%(0)
          score% = score% + 15
          if score% >= 18000 then                    
            if qlives% <= 3 then
              if exlife2_flag=TRUE then            
                inc qlives%            
                manage_lives(qlives%)
                exlife2_flag=FALSE
              end if
            end if
          end if
    
          inc field%(tmp_loc!(0),tmp_loc!(1))

        else if field%(tmp_loc!(0),tmp_loc!(1)) = 1 then
          math add x1%(),(tmp_loc!(0)-7)*16,nextx1%()
          math add y1%(),(tmp_loc!(1)-1)*28,nexty1%()
          polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
    
          inc field%(tmp_loc!(0),tmp_loc!(1))
          score% = score% + 25
          inc cube_cnt%
        end if

      end if



      pause 30
      sprite hide b_spr%+1 'QBERT+DNRIGHT+1 
      'fix top on top cube from original background resotored
      if level% = 1 then
        if qbert_location!(0) = 7 then
          math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
          math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
          polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
        end if
      end if
      sprite show b_spr%,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0)),1,qr% 'QBERT+DNRIGHT
      cur_spr% = b_spr%


      qbert_location!(0) = tmp_loc!(0)
      qbert_location!(1) = tmp_loc!(1)

mmdebug      text 100,10,"cube count = "+str$(cube_cnt%)+" ",L,,,RGB(WHITE)
    
  
      if cube_cnt% = 28 then   'round complete
        cube_flash
        sprite hide cur_spr%
        if sprite(x,c_cur_spr%) <> 10000 then
          sprite hide c_cur_spr%
        end if
        select case round%
          case 1
            bonus% = 1000
          case 2
            bonus% = 1250
          case 3
            bonus% = 1500
          case 4
            bonus% = 1750
        end select
        bonus% = bonus% * level%
        score% = score% + bonus%
        score% = score% + discnt% * 50
        cube_cnt% = 0
        draw_cubes(TRUE)
        qbert_location(0) = 7
        qbert_location(1) = 1
        coily_location!(0) = 0
        coily_location!(1) = 0
        for w% = 0 to reggs%-1
          redegg_location!(w%,0) = 0
          redegg_location!(w%,1) = 0
        next

        drop_in(TRUE)
      end if
        pflag% = FALSE



      case -1
        play modsample 5,2,64,22050   'fall.wav  all qbert sounds on channel 2

       sprite show safe cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0))-14),1,qr%
       pause 50

       l% = 0
       do while sprite(y,cur_spr%) < 400
         sprite show cur_spr%,sprite(x,cur_spr%),sprite(y,cur_spr%)+l%,1
         inc l%
         pause 5
       loop


       sprite hide cur_spr%

        qstate = dead
        pflag% = FALSE
'        inc qlives%,-1
'        manage_lives(qlives%)
         cflag% = QBERT
         collision_recover 

      
      case 255
       qbert_location!(0) = sdisc!(1,1)
       qbert_location!(1) = sdisc!(1,2)    
       sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
       cur_spr% = b_spr%+1
       pause 10
       sprite hide b_spr%+1 'QBERT+DNRIGHT+1
       pause 2
       play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2       
        elevator(1,1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE
  
      case 254
        qbert_location!(0) = sdisc!(2,1)
        qbert_location!(1) = sdisc!(2,2)    
        sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(2,-1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE
      
      case 253
        qbert_location!(0) = sdisc!(3,1)
        qbert_location!(1) = sdisc!(3,2)    
        sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(3,1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE

      case 252
        qbert_location!(0) = sdisc!(4,1)
        qbert_location!(1) = sdisc!(4,2)    
        sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(4,-1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE


      case 251
        qbert_location!(0) = sdisc!(5,1)
        qbert_location!(1) = sdisc!(5,2)    
        sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(5,1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE


      case 250
        qbert_location!(0) = sdisc!(6,1)
        qbert_location!(1) = sdisc!(6,2)    
        sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(6,-1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE


      case 249
        qbert_location!(0) = sdisc!(7,1)
        qbert_location!(1) = sdisc!(7,2)    
        sprite show b_spr%+1,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1))-5,1,qr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(7,1)
        inc disccnt%,-1
        field%(tmp_loc!(0),tmp_loc!(1)) = -1
        cly_int% = 500
        settick cly_int%,coilly,1
         pflag% = FALSE

    end select

 cf% = FALSE



      if cflag% = COILY then
        collision_recover
        settick cly_int%,coilly,1
        settick rdg_int%,redeg,4
      else if cflag% = REDEGG then
end
        collision_recover
        settick cly_int%,coilly,1
        settick rdg_int%,redeg,4
      end if

      cflag% = FALSE



end sub     'hop


sub calc_discs(l%,r%)
  local d%,i%,idx%,numdiscs%

  if l% = 1 then numdiscs% = 2
  if l% = 2 then
    numdiscs% = 3
    if round% = 3 then numdiscs% = 2
  end if
  if l% = 3 then
    numdiscs% = 4
    if round% = 3 then numdiscs% = 3
  end if
  
  discnt% = numdiscs%


  i% = 1 
  if i% <= numdiscs% then
    idx% = cint(rnd*6)+1
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 255
  end if

  i% = i% + 1 '2
  if i% <= numdiscs% then
    sdisc!(i%,0)  = TRUE
    idx% = cint(rnd*6)+1
    sdisc!(i%,1) =  disc_pairs(idx%+7,0)
    sdisc!(i%,2) =  disc_pairs(idx%+7,1)
    field%(disc_pairs(idx%+7,0)-.5,disc_pairs(idx%+7,1)-1.2) = 254
  end if

  i% = i% + 1 '3
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%,0) = sdisc(1,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 253
  else
      sdisc!(i%,0) = FALSE
  end if
  

  i% = i% + 1 '4
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%+7,0) = sdisc(2,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%+7,0)
    sdisc!(i%,2) =  disc_pairs(idx%+7,1)
    field%(disc_pairs(idx%+7,0)-.5,disc_pairs(idx%+7,1)-1.2) = 252
  else
      sdisc!(i%,0) = FALSE
  end if

  i% = i% + 1 '5
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%,0) = sdisc(1,1) and disc_pairs(idx%,0) = sdisc(3,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 251
  else
      sdisc!(i%,0) = FALSE
  end if

  i% = i% + 1 '6
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%+7,0) = sdisc(2,1) and disc_pairs(idx%+7,0) = sdisc(4,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%+7,0)
    sdisc!(i%,2) =  disc_pairs(idx%+7,1)
    field%(disc_pairs(idx%+7,0)-.5,disc_pairs(idx%+7,1)-1.2) = 250
  else
      sdisc!(i%,0) = FALSE
  end if

  i% = i% + 1 '7
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%,0) = sdisc(1,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 249
  else
      sdisc!(i%,0) = FALSE
  end if

end sub


sub SelectInputDevice(skip_device%)
  local i,d

  
  for i = 0  to 3
    on error skip
    controller nunchuk open i
    if mm.errno > 0 then
      next
    else
      on error skip
      errno = nunchuk(t,i)
      if errno <> &Ha4200000 then

         HaveClassic = TRUE
          controller nunchuk close
          controller classic open i,button_pressed,&b111101110
          channel = i
          exit for
      else if errno = &ha4200000 then
        channel = i
        HaveNunchuk = TRUE
'        settick 7,pollclassic,1
        exit for     
      end if
    end if

  if channel > -1 then exit sub

  keyboard = TRUE
'  settick 20,pollkeyboard,1
end sub

sub button_pressed
  local pressed

    if qstate = DEAD then exit sub  
    if cflag% > 0 then exit sub
    if pflag% = TRUE then exit sub

        pressed = classic(b)        
        
        select case pressed and &b111111111
          case 2  ' start button

          case 4  ' home button
          
          case 8  ' select button
          
          case 32 ' cursor down
            pflag% = TRUE        
            hop(1,1)
            exit sub
          
          case 64 ' cursor right
            pflag% = TRUE        
            hop(1,-1)  
            exit sub
          
          case 128  'cursor up
            pflag% = TRUE        
            hop(-1,-1)
            exit sub
          
          case 256  'cursor left
            pflag% = TRUE        
            hop(-1,1)
            exit sub
            
         end select

    
end sub

sub pollkeyboard
     If xp% <> oldxp% or yp% <> oldyp% Then
       oldxp% = xp% : oldyp% = yp%
       GUI CURSOR XP%,YP%
    end if
end sub

sub draw_cubes(clflag%)
if clflag% then
  cls

  timer = 0

  flg% = TRUE



  ' player numer
  blit write 62,68,8
  'level
  blit write 61,340,80
  level_colr% = pixel(343,85)


  'round
  blit write 60,340,90
  round_colr% = pixel(340,95)


  'change to
  blit write 59,10,50


'  reset playfield
  math scale playfield%(),1,field%()
  calc_discs(level%,round%)
'  math add y%(),-(3*56),y%()


end if

if level% = 1 then

  select case round%
    case 1
      restore level11
    case 2
      restore level12
    case 3
      restore level13
    case 4
      restore level14
  end select

end if

if level% = 2 then

  select case round%
    case 1
      restore level21
    case 2
      restore level22
    case 3
      restore level23
    case 4
      restore level24
  end select

end if



for z = 0 to 2
  read startcolor%(z)
next


polygon c%(),x%(),y%(),startcolor%(),startcolor%()

for l% = 1 to 3
  for i% = 1 to k%
      math add x%(),-(i%*16),nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),startcolor%(),startcolor%()
      
      math add x%(),i%*16,nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),startcolor%(),startcolor%()

  next

  math add y%(),56,y%()
  polygon c%(),x%(),y%(),startcolor%(),startcolor%()
  k% = k% - 2
next
page copy 0 to 4,b


page write 5
cls
k% = 6

'shift cubes back to the original y position
math add y%(),-(3*56),y%()

for z = 0 to 2
  read finishcolor%(z)
next

if level% = 2 then
  for z = 0 to 2
    read color1%(z)
  next
end if

polygon c%(),x%(),y%(),finishcolor%(),finishcolor%()

page write 0

image resize 224,92,32,36,90,45,16,18,5


page write 5
for l% = 1 to 3
  for i% = 1 to k%

      math add x%(),-(i%*16),nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),finishcolor%(),finishcolor%()
      
      math add x%(),i%*16,nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),finishcolor%(),finishcolor%()

  next

  math add y%(),56,y%()
  polygon c%(),x%(),y%(),finishcolor%(),finishcolor%()
  k% = k% - 2
next

  math add y%(),-(3*56),y%()

  k% = 6
page write 0

' used for cube flashing
blit read 64,120,89,9*28,9*28
blit read 63,120,89,9*28,9*28,5




end sub
